gitweb: [commit view] Do not suppress commitdiff link in root commit
[git/dscho.git] / git-commit.sh
blob6f6cbda8984e51daba7aae582036b4f821eae51b
1 #!/bin/sh
3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-u] [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
7 SUBDIRECTORY_OK=Yes
8 . git-sh-setup
10 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
11 branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)
13 case "$0" in
14 *status)
15 status_only=t
16 unmerged_ok_if_status=--unmerged ;;
17 *commit)
18 status_only=
19 unmerged_ok_if_status= ;;
20 esac
22 refuse_partial () {
23 echo >&2 "$1"
24 echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
25 exit 1
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
30 rm -f "$NEXT_INDEX"
31 save_index () {
32 cp -p "$THIS_INDEX" "$NEXT_INDEX"
35 run_status () {
36 # If TMP_INDEX is defined, that means we are doing
37 # "--only" partial commit, and that index file is used
38 # to build the tree for the commit. Otherwise, if
39 # NEXT_INDEX exists, that is the index file used to
40 # make the commit. Otherwise we are using as-is commit
41 # so the regular index file is what we use to compare.
42 if test '' != "$TMP_INDEX"
43 then
44 GIT_INDEX_FILE="$TMP_INDEX"
45 export GIT_INDEX_FILE
46 elif test -f "$NEXT_INDEX"
47 then
48 GIT_INDEX_FILE="$NEXT_INDEX"
49 export GIT_INDEX_FILE
52 case "$status_only" in
53 t) color= ;;
54 *) color=--nocolor ;;
55 esac
56 git-runstatus ${color} \
57 ${verbose:+--verbose} \
58 ${amend:+--amend} \
59 ${untracked_files:+--untracked}
62 trap '
63 test -z "$TMP_INDEX" || {
64 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
66 rm -f "$NEXT_INDEX"
67 ' 0
69 ################################################################
70 # Command line argument parsing and sanity checking
72 all=
73 also=
74 only=
75 logfile=
76 use_commit=
77 amend=
78 edit_flag=
79 no_edit=
80 log_given=
81 log_message=
82 verify=t
83 verbose=
84 signoff=
85 force_author=
86 only_include_assumed=
87 untracked_files=
88 while case "$#" in 0) break;; esac
90 case "$1" in
91 -F|--F|-f|--f|--fi|--fil|--file)
92 case "$#" in 1) usage ;; esac
93 shift
94 no_edit=t
95 log_given=t$log_given
96 logfile="$1"
97 shift
99 -F*|-f*)
100 no_edit=t
101 log_given=t$log_given
102 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
103 shift
105 --F=*|--f=*|--fi=*|--fil=*|--file=*)
106 no_edit=t
107 log_given=t$log_given
108 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
109 shift
111 -a|--a|--al|--all)
112 all=t
113 shift
115 --au=*|--aut=*|--auth=*|--autho=*|--author=*)
116 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
117 shift
119 --au|--aut|--auth|--autho|--author)
120 case "$#" in 1) usage ;; esac
121 shift
122 force_author="$1"
123 shift
125 -e|--e|--ed|--edi|--edit)
126 edit_flag=t
127 shift
129 -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
130 also=t
131 shift
133 -o|--o|--on|--onl|--only)
134 only=t
135 shift
137 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
138 case "$#" in 1) usage ;; esac
139 shift
140 log_given=m$log_given
141 if test "$log_message" = ''
142 then
143 log_message="$1"
144 else
145 log_message="$log_message
149 no_edit=t
150 shift
152 -m*)
153 log_given=m$log_given
154 if test "$log_message" = ''
155 then
156 log_message=`expr "z$1" : 'z-m\(.*\)'`
157 else
158 log_message="$log_message
160 `expr "z$1" : 'z-m\(.*\)'`"
162 no_edit=t
163 shift
165 --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
166 log_given=m$log_given
167 if test "$log_message" = ''
168 then
169 log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
170 else
171 log_message="$log_message
173 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
175 no_edit=t
176 shift
178 -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|--no-verify)
179 verify=
180 shift
182 --a|--am|--ame|--amen|--amend)
183 amend=t
184 log_given=t$log_given
185 use_commit=HEAD
186 shift
189 case "$#" in 1) usage ;; esac
190 shift
191 log_given=t$log_given
192 use_commit="$1"
193 no_edit=
194 shift
196 --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
197 --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
198 --reedit-messag=*|--reedit-message=*)
199 log_given=t$log_given
200 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
201 no_edit=
202 shift
204 --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
205 --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|--reedit-message)
206 case "$#" in 1) usage ;; esac
207 shift
208 log_given=t$log_given
209 use_commit="$1"
210 no_edit=
211 shift
214 case "$#" in 1) usage ;; esac
215 shift
216 log_given=t$log_given
217 use_commit="$1"
218 no_edit=t
219 shift
221 --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
222 --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
223 --reuse-message=*)
224 log_given=t$log_given
225 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
226 no_edit=t
227 shift
229 --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
230 --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
231 case "$#" in 1) usage ;; esac
232 shift
233 log_given=t$log_given
234 use_commit="$1"
235 no_edit=t
236 shift
238 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
239 signoff=t
240 shift
242 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
243 verbose=t
244 shift
246 -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|--untracked|\
247 --untracked-|--untracked-f|--untracked-fi|--untracked-fil|--untracked-file|\
248 --untracked-files)
249 untracked_files=t
250 shift
253 shift
254 break
257 usage
260 break
262 esac
263 done
264 case "$edit_flag" in t) no_edit= ;; esac
266 ################################################################
267 # Sanity check options
269 case "$amend,$initial_commit" in
270 t,t)
271 die "You do not have anything to amend." ;;
273 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
274 die "You are in the middle of a merge -- cannot amend."
275 fi ;;
276 esac
278 case "$log_given" in
279 tt*)
280 die "Only one of -c/-C/-F can be used." ;;
281 *tm*|*mt*)
282 die "Option -m cannot be combined with -c/-C/-F." ;;
283 esac
285 case "$#,$also,$only,$amend" in
286 *,t,t,*)
287 die "Only one of --include/--only can be used." ;;
288 0,t,,* | 0,,t,)
289 die "No paths with --include/--only does not make sense." ;;
290 0,,t,t)
291 only_include_assumed="# Clever... amending the last one with dirty index." ;;
292 0,,,*)
294 *,,,*)
295 only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
296 also=
298 esac
299 unset only
300 case "$all,$also,$#" in
301 t,t,*)
302 die "Cannot use -a and -i at the same time." ;;
303 t,,[1-9]*)
304 die "Paths with -a does not make sense." ;;
305 ,t,0)
306 die "No paths with -i does not make sense." ;;
307 esac
309 ################################################################
310 # Prepare index to have a tree to be committed
312 TOP=`git-rev-parse --show-cdup`
313 if test -z "$TOP"
314 then
315 TOP=./
318 case "$all,$also" in
320 save_index &&
322 cd "$TOP"
323 GIT_INDEX_FILE="$NEXT_INDEX"
324 export GIT_INDEX_FILE
325 git-diff-files --name-only -z |
326 git-update-index --remove -z --stdin
330 save_index &&
331 git-ls-files --error-unmatch -- "$@" >/dev/null || exit
333 git-diff-files --name-only -z -- "$@" |
335 cd "$TOP"
336 GIT_INDEX_FILE="$NEXT_INDEX"
337 export GIT_INDEX_FILE
338 git-update-index --remove -z --stdin
342 case "$#" in
344 ;; # commit as-is
346 if test -f "$GIT_DIR/MERGE_HEAD"
347 then
348 refuse_partial "Cannot do a partial commit during a merge."
350 TMP_INDEX="$GIT_DIR/tmp-index$$"
351 if test -z "$initial_commit"
352 then
353 # make sure index is clean at the specified paths, or
354 # they are additions.
355 dirty_in_index=`git-diff-index --cached --name-status \
356 --diff-filter=DMTU HEAD -- "$@"`
357 test -z "$dirty_in_index" ||
358 refuse_partial "Different in index and the last commit:
359 $dirty_in_index"
361 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
363 # Build the temporary index and update the real index
364 # the same way.
365 if test -z "$initial_commit"
366 then
367 cp "$THIS_INDEX" "$TMP_INDEX"
368 GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
369 else
370 rm -f "$TMP_INDEX"
371 fi || exit
373 echo "$commit_only" |
374 GIT_INDEX_FILE="$TMP_INDEX" \
375 git-update-index --add --remove --stdin &&
377 save_index &&
378 echo "$commit_only" |
380 GIT_INDEX_FILE="$NEXT_INDEX"
381 export GIT_INDEX_FILE
382 git-update-index --remove --stdin
383 ) || exit
385 esac
387 esac
389 ################################################################
390 # If we do as-is commit, the index file will be THIS_INDEX,
391 # otherwise NEXT_INDEX after we make this commit. We leave
392 # the index as is if we abort.
394 if test -f "$NEXT_INDEX"
395 then
396 USE_INDEX="$NEXT_INDEX"
397 else
398 USE_INDEX="$THIS_INDEX"
401 GIT_INDEX_FILE="$USE_INDEX" \
402 git-update-index -q $unmerged_ok_if_status --refresh || exit
404 ################################################################
405 # If the request is status, just show it and exit.
407 case "$0" in
408 *status)
409 run_status
410 exit $?
411 esac
413 ################################################################
414 # Grab commit message, write out tree and make commit.
416 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
417 then
418 if test "$TMP_INDEX"
419 then
420 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
421 else
422 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
423 fi || exit
426 if test "$log_message" != ''
427 then
428 echo "$log_message"
429 elif test "$logfile" != ""
430 then
431 if test "$logfile" = -
432 then
433 test -t 0 &&
434 echo >&2 "(reading log message from standard input)"
436 else
437 cat <"$logfile"
439 elif test "$use_commit" != ""
440 then
441 git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
442 elif test -f "$GIT_DIR/MERGE_HEAD" && test -f "$GIT_DIR/MERGE_MSG"
443 then
444 cat "$GIT_DIR/MERGE_MSG"
445 elif test -f "$GIT_DIR/SQUASH_MSG"
446 then
447 cat "$GIT_DIR/SQUASH_MSG"
448 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
450 case "$signoff" in
453 echo
454 git-var GIT_COMMITTER_IDENT | sed -e '
455 s/>.*/>/
456 s/^/Signed-off-by: /
458 } >>"$GIT_DIR"/COMMIT_EDITMSG
460 esac
462 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
463 echo "#"
464 echo "# It looks like you may be committing a MERGE."
465 echo "# If this is not correct, please remove the file"
466 echo "# $GIT_DIR/MERGE_HEAD"
467 echo "# and try again"
468 echo "#"
469 fi >>"$GIT_DIR"/COMMIT_EDITMSG
471 # Author
472 if test '' != "$force_author"
473 then
474 GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
475 GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
476 test '' != "$GIT_AUTHOR_NAME" &&
477 test '' != "$GIT_AUTHOR_EMAIL" ||
478 die "malformed --author parameter"
479 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
480 elif test '' != "$use_commit"
481 then
482 pick_author_script='
483 /^author /{
484 s/'\''/'\''\\'\'\''/g
486 s/^author \([^<]*\) <[^>]*> .*$/\1/
487 s/'\''/'\''\'\'\''/g
488 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
491 s/^author [^<]* <\([^>]*\)> .*$/\1/
492 s/'\''/'\''\'\'\''/g
493 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
496 s/^author [^<]* <[^>]*> \(.*\)$/\1/
497 s/'\''/'\''\'\'\''/g
498 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
503 set_author_env=`git-cat-file commit "$use_commit" |
504 LANG=C LC_ALL=C sed -ne "$pick_author_script"`
505 eval "$set_author_env"
506 export GIT_AUTHOR_NAME
507 export GIT_AUTHOR_EMAIL
508 export GIT_AUTHOR_DATE
511 PARENTS="-p HEAD"
512 if test -z "$initial_commit"
513 then
514 rloga='commit'
515 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
516 rloga='commit (merge)'
517 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
518 elif test -n "$amend"; then
519 rloga='commit (amend)'
520 PARENTS=$(git-cat-file commit HEAD |
521 sed -n -e '/^$/q' -e 's/^parent /-p /p')
523 current=$(git-rev-parse --verify HEAD)
524 else
525 if [ -z "$(git-ls-files)" ]; then
526 echo >&2 Nothing to commit
527 exit 1
529 PARENTS=""
530 current=
531 rloga='commit (initial)'
534 if test -z "$no_edit"
535 then
537 echo ""
538 echo "# Please enter the commit message for your changes."
539 echo "# (Comment lines starting with '#' will not be included)"
540 test -z "$only_include_assumed" || echo "$only_include_assumed"
541 run_status
542 } >>"$GIT_DIR"/COMMIT_EDITMSG
543 else
544 # we need to check if there is anything to commit
545 run_status >/dev/null
547 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
548 then
549 rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
550 run_status
551 exit 1
554 case "$no_edit" in
556 case "${VISUAL:-$EDITOR},$TERM" in
557 ,dumb)
558 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
559 echo >&2 "Please supply the commit log message using either"
560 echo >&2 "-m or -F option. A boilerplate log message has"
561 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
562 exit 1
564 esac
565 git-var GIT_AUTHOR_IDENT > /dev/null || die
566 git-var GIT_COMMITTER_IDENT > /dev/null || die
567 ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
569 esac
571 case "$verify" in
573 if test -x "$GIT_DIR"/hooks/commit-msg
574 then
575 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
577 esac
579 if test -z "$no_edit"
580 then
581 sed -e '
582 /^diff --git a\/.*/{
583 s///
586 /^#/d
587 ' "$GIT_DIR"/COMMIT_EDITMSG
588 else
589 cat "$GIT_DIR"/COMMIT_EDITMSG
590 fi |
591 git-stripspace >"$GIT_DIR"/COMMIT_MSG
593 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
594 git-stripspace |
595 wc -l` &&
596 test 0 -lt $cnt
597 then
598 if test -z "$TMP_INDEX"
599 then
600 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
601 else
602 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
603 rm -f "$TMP_INDEX"
604 fi &&
605 commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
606 rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
607 git-update-ref -m "$rloga: $rlogm" HEAD $commit $current &&
608 rm -f -- "$GIT_DIR/MERGE_HEAD" &&
609 if test -f "$NEXT_INDEX"
610 then
611 mv "$NEXT_INDEX" "$THIS_INDEX"
612 else
613 : ;# happy
615 else
616 echo >&2 "* no commit message? aborting commit."
617 false
619 ret="$?"
620 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
621 if test -d "$GIT_DIR/rr-cache"
622 then
623 git-rerere
626 if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
627 then
628 "$GIT_DIR"/hooks/post-commit
630 exit "$ret"